import unittest

from worktime import humanize, parser

format1 = ('ежед.', 'пн', 'вт', 'ср', 'чт', 'пт', 'сб', 'вс')
format2 = ('ежедневно', 'понедельник', 'вторник', 'среда', 'четверг', 'пятница', 'суббота', 'воскресенье')

tests = [
    ['9.00-20.00, сб. 10.00-17.00, вс - вых.'],
    ['9.00-18.00, сб, вс - вых'],
    ['Работает ежедневно 00:00–23:00'],
    ['Работает пн-чт 06:30–23:00'],
    ['пн, вт, чт 06:30–23:00'],
    'Понедельник 12:00 – 24:00, Вторник 12:00 – 24:00,'
    'Среда 12:00 – 24:00, Четверг 12:00 – 24:00,'
    'Пятница 12:00 – 02:00, Суббота 12:00 – 02:00,'
    'Воскресенье 12:00 – 02:00'.split(','),
    'пн с 10:00 до 18:00,вт с 10:00 до 18:00,ср с 10:00 до 18:00'.split(','),
    'пн с 10:00 до 18:00,вт с 10:00 - 18:00,ср с 10:00 - 18:00'.split(','),
    ['пн-чт 8:00-10:00'],
    ['Понедельник, Среда, Пятница 10:00-13:25, 14:00 - 18:20'],
    [
        "Thu 10:00-24:00",
        "Sat 10:00-03:00",
        "Tue 10:00-24:00",
        "Sun 10:00-24:00",
        "Mon 10:00-24:00",
        "Wed 10:00-24:00",
        "Fri 10:00-03:00"
    ],
    ['Пн-пт 10.00-21.00', 'сб 11.00-21.00', 'вс 11.00-20.00'],  # 1
    ['вс–чт 9.00–0.00', 'пт, сб 9.00–6.00'],  # 2
    ['пн–пт 12.00–22.30; сб, вс 14.00–22.30'],  # 3
    'Пн: 09:00 - 18:00, Вт: 09:00 - 18:00, '
    'Ср: 09:00 - 18:00, Чт: 09:00 - 18:00, '
    'Пт: 09:00 - 18:00, '
    'Сб: Закрыто сейчас, Вс: Закрыто сейчас'.split(','),
    ['ежедневно круглосуточно'],
    ['пн.-пт.: 10:00-21:00', 'сб.-вс.: 10:00-19:00']
]


class Unittest(unittest.TestCase):
    def test_parser(self):
        results = [
            {'1': ['09:00-20:00'], '2': ['09:00-20:00'], '3': ['09:00-20:00'], '4': ['09:00-20:00'], '5': ['09:00-20:00'], '6': ['10:00-17:00']},
            {'1': ['09:00-18:00'], '2': ['09:00-18:00'], '3': ['09:00-18:00'], '4': ['09:00-18:00'], '5': ['09:00-18:00']},
            {'1': ['00:00-23:00'], '2': ['00:00-23:00'], '3': ['00:00-23:00'], '4': ['00:00-23:00'], '5': ['00:00-23:00'], '6': ['00:00-23:00'], '7': ['00:00-23:00']},
            {'1': ['06:30-23:00'], '2': ['06:30-23:00'], '3': ['06:30-23:00'], '4': ['06:30-23:00']},
            {'1': ['06:30-23:00'], '2': ['06:30-23:00'], '4': ['06:30-23:00']},
            {'1': ['12:00-23:59'], '2': ['12:00-23:59'], '3': ['12:00-23:59'], '4': ['12:00-23:59'], '5': ['12:00-02:00'], '6': ['12:00-02:00'], '7': ['12:00-02:00']},
            {'1': ['10:00-18:00'], '2': ['10:00-18:00'], '3': ['10:00-18:00']},
            {'1': ['10:00-18:00'], '2': ['10:00-18:00'], '3': ['10:00-18:00']},
            {'1': ['08:00-10:00'], '2': ['08:00-10:00'], '3': ['08:00-10:00'], '4': ['08:00-10:00']},
            {'1': ['10:00-13:25', '14:00-18:20'], '3': ['10:00-13:25', '14:00-18:20'], '5': ['10:00-13:25', '14:00-18:20']},
            {'1': ['10:00-23:59'], '2': ['10:00-23:59'], '3': ['10:00-23:59'], '4': ['10:00-23:59'], '5': ['10:00-03:00'], '6': ['10:00-03:00'], '7': ['10:00-23:59']},
            {'1': ['10:00-21:00'], '2': ['10:00-21:00'], '3': ['10:00-21:00'], '4': ['10:00-21:00'], '5': ['10:00-21:00'], '6': ['11:00-21:00'], '7': ['11:00-20:00']},
            {'1': ['09:00-23:59'], '2': ['09:00-23:59'], '3': ['09:00-23:59'], '4': ['09:00-23:59'], '5': ['09:00-06:00'], '6': ['09:00-06:00'], '7': ['09:00-23:59']},
            {'1': ['12:00-22:30'], '2': ['12:00-22:30'],
             '3': ['12:00-22:30'], '4': ['12:00-22:30'],
             '5': ['12:00-22:30'], '6': ['14:00-22:30'],
             '7': ['14:00-22:30']},
            {'1': ['09:00-18:00'], '2': ['09:00-18:00'], '3': ['09:00-18:00'], '4': ['09:00-18:00'], '5': ['09:00-18:00']},
            {'1': ['00:00-23:59'], '2': ['00:00-23:59'], '3': ['00:00-23:59'], '4': ['00:00-23:59'], '5': ['00:00-23:59'], '6': ['00:00-23:59'], '7': ['00:00-23:59']},
            {'1': ['10:00-21:00'], '2': ['10:00-21:00'], '3': ['10:00-21:00'], '4': ['10:00-21:00'], '5': ['10:00-21:00'], '6': ['10:00-19:00'], '7': ['10:00-19:00']},
        ]
        t = zip(tests, results)
        for test in t:
            rez = parser(test[0])
            self.assertEqual(test[1], rez)

    def test_humanize_overflow(self):
        results = [
            'пн-пт 09:00-20:00; сб 10:00-17:00',
            'пн-пт 09:00-18:00',
            'ежедневно 00:00-23:00',
            'пн-чт 06:30-23:00',
            'пн,вт,чт 06:30-23:00',
            'пн-чт 12:00-23:59; пт-вс 12:00-02:00',
            'пн-ср 10:00-18:00',
            'пн-ср 10:00-18:00',
            'пн-чт 08:00-10:00',
            'пн,ср,пт 10:00-13:25,14:00-18:20',
            'пн,вт,ср,чт,вс 10:00-23:59; пт-сб 10:00-03:00',
            'пн-пт 10:00-21:00; сб 11:00-21:00; вс 11:00-20:00',
            'пн,вт,ср,чт,вс 09:00-23:59; пт-сб 09:00-06:00',
            'пн-пт 12:00-22:30; сб-вс 14:00-22:30',
            'пн-пт 09:00-18:00',
            'ежедневно круглосуточно',
            'пн-пт 10:00-21:00; сб-вс 10:00-19:00'
        ]
        t = zip(tests, results)
        for test in t:
            rez = humanize(
                parser(test[0]),
                days=('ежед.', 'пн', 'вт', 'ср', 'чт', 'пт', 'сб', 'вс'),
                overflow=('ежедневно', 'круглосуточно'),
                separators={'times': ','}
            )
            self.assertEqual(test[1], rez)

    def test_humanize_separators(self):
        results = [
            'пн-пт 09:00-20:00, сб 10:00-17:00',
            'пн-пт 09:00-18:00',
            'пн-вс 00:00-23:00',
            'пн-чт 06:30-23:00',
            'пн,вт,чт 06:30-23:00',
            'пн-чт 12:00-23:59, пт-вс 12:00-02:00',
            'пн-ср 10:00-18:00',
            'пн-ср 10:00-18:00',
            'пн-чт 08:00-10:00',
            'пн,ср,пт 10:00-13:25; 14:00-18:20',
            'пн,вт,ср,чт,вс 10:00-23:59, пт-сб 10:00-03:00',
            'пн-пт 10:00-21:00, сб 11:00-21:00, вс 11:00-20:00',
            'пн,вт,ср,чт,вс 09:00-23:59, пт-сб 09:00-06:00',
            'пн-пт 12:00-22:30, сб-вс 14:00-22:30',
            'пн-пт 09:00-18:00',
            'пн-вс 00:00-23:59',
            'пн-пт 10:00-21:00, сб-вс 10:00-19:00'
        ]
        t = zip(tests, results)
        for test in t:
            rez = humanize(
                parser(test[0]),
                days=('ежед.', 'пн', 'вт', 'ср', 'чт', 'пт', 'сб', 'вс'),
                separators={'days': ',', 'times': '; ', 'range': ', '}
            )
            self.assertEqual(test[1], rez)

    def test_humanize_overflow_separators(self):
        results = [
            'пн-пт 09:00-20:00, сб 10:00-17:00',
            'пн-пт 09:00-18:00',
            'ежедневно 00:00-23:00',
            'пн-чт 06:30-23:00',
            'пн,вт,чт 06:30-23:00',
            'пн-чт 12:00-23:59, пт-вс 12:00-02:00',
            'пн-ср 10:00-18:00',
            'пн-ср 10:00-18:00',
            'пн-чт 08:00-10:00',
            'пн,ср,пт 10:00-13:25; 14:00-18:20',
            'пн,вт,ср,чт,вс 10:00-23:59, пт-сб 10:00-03:00',
            'пн-пт 10:00-21:00, сб 11:00-21:00, вс 11:00-20:00',
            'пн,вт,ср,чт,вс 09:00-23:59, пт-сб 09:00-06:00',
            'пн-пт 12:00-22:30, сб-вс 14:00-22:30',
            'пн-пт 09:00-18:00',
            'ежедневно круглосуточно',
            'пн-пт 10:00-21:00, сб-вс 10:00-19:00'
        ]
        t = zip(tests, results)
        for test in t:
            rez = humanize(
                parser(test[0]),
                days=('ежед.', 'пн', 'вт', 'ср', 'чт', 'пт', 'сб', 'вс'),
                separators={'days': ',', 'times': '; ', 'range': ', '},
                overflow=('ежедневно', 'круглосуточно')
            )
            self.assertEqual(test[1], rez)


if __name__ == '__main__':
    unittest.main()
